module RubyKpi

  ##################################################
  #
  # The URI class
  #
  ##################################################

  class URI

    # accessor
    attr_reader :value

    # constructor
    def initialize(value)
      if value
        @value = value
      else
        @value = "http://www.nokia.com/NRC/M3/sib#any"
      end
    end

    # to string
    def to_str()
      return "<" + @value + ">"
    end

  end


  ##################################################
  #
  # The Literal class
  #
  ##################################################

  class Literal

    # accessor
    attr_reader :value

    # constructor
    def initialize(value)
      @value = value
    end

    # to string
    def to_str()
      return @value
    end

  end


  ##################################################
  #
  # The Triple class
  #
  ##################################################

  class Triple

    # accessor
    attr_reader :subject, :predicate, :object

    # constructor
    def initialize(subject, predicate, object)
      
      # subject
      @subject = subject

      # predicate
      @predicate = predicate

      # object
      @object = object

    end

    # to string
    def to_str()
      
      return "[" + @subject.to_str() + ", " + @predicate.to_str() + ", " + @object.to_str() + "]"

    end
 
  end


end
